;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;                                                                      ;;;;
;;;;                          SALAR COMPUTER Co.                          ;;;;
;;;;                                                                      ;;;;   
;;;;   This porogram is written by Ali Reza Ebrahimy.                     ;;;;
;;;;                                                                      ;;;;
;;;;   This software is used for writing farsi text in AutoCAD drawing    ;;;;
;;;;                                                                      ;;;;
;;;;   editor.                                                            ;;;;
;;;;                                                                      ;;;;
;;;;   For running this porogram :                                        ;;;;
;;;;                                                                      ;;;;
;;;;      1) Load it with "(load "sf")" command.                          ;;;;
;;;;                                                                      ;;;;
;;;;      2) Run it with "sf" command.                                    ;;;;
;;;;                                                                      ;;;;
;;;;   Address:                                                           ;;;;
;;;;      D5 - 5th Floor - Eskan Bld. - Abresani sq. - TABRIZ - IRAN      ;;;;
;;;;                                                                      ;;;;
;;;;   Tel : 041 - 346362                                                 ;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(princ "\nAli Reza Ebrahimy. SALAR COMPUTER Co. Tel: 041-346362 ")
(princ "\nFarsi software is loading .")

(defun r_t_d (d) (setq d (/ (* d 180.0) pi)))

(princ "..")

(defun lspt (d) (setvar "lastpoint" st))

(princ "..")

(defun *error* (ms)
  (if (= ms "Function cancelled")
    (command)
  )
  (princ "\nerror: ")
  (princ ms)
  (if ss (command "ERASE" ss ""))
  (setvar "CMDECHO" 1)
  (setvar "HIGHLIGHT" 1)
  (setvar "BLIPMODE" 1)
  (princ)
)

(princ "..")

(setq chr1 (list 104 151 152 153 78 110 169 170 171 66 98 133 134
		 135 67 99 136 137 138 70 92 124 211 212 213 44 226
		 227 228 60 229 230 231 62 232 233 234 235 236 237
		 32 71 72 86 118 193 194 195 167 168)
      chr2 (list 32 33 35 36 37 38 40 41 42 43 45 46 47 48 49 50 51 
		 52 53 54 55 56 57 61 63 64 94 127 128 129)
      chr3 (append chr1 chr2)
      chr4 (append chr2 (list 32 70 71 72))
      chr5 (list (list 96 126) (list 58 127) (list 59 127) (list 34 128)
		 (list 39 128) (list 44 129) (list 60 131) (list 62 132)
	   )
      chr6 (list 96 58 59 34 39 44 60 62)
      chr7 (list 104 110 98 99 118 124 129 130 131)
)

(princ "..")

(defun check_style (/ temp)
  (setq st_fn (tblnext "style" T))
  (if (wcmatch (cdr (assoc 3 st_fn)) "*NASKHD*,*naskhd*,*NASIM*,*nasim*") 
    (setq temp "T")
  )
  (while (and (setq st_fn (tblnext "style")) (= temp nil))
    (if (wcmatch (cdr (assoc 3 st_fn)) "*NASKHD*,*naskhd*,*NASIM*,*nasim*") 
      (setq temp "T")
    )
  )
  (if (not temp)
    (progn 
      (alert (strcat "              !!! ERROR !!!"
		     "\n\nStyle with font file \"NASKHD\" or \"NASKHN\"" 
		     "\nis not available."
		     "\nUse \"STYLE\" command and define text style"
		     "\nwith above font files name."
	     )
      )
      (exit)
    )
    (progn
      (if (not (wcmatch (cdr (assoc 3 (tblsearch "STYLE" (getvar "TEXTSTYLE")))) 
		   "*NASKHD*,*naskhd*,*NASKHN*,*naskhn*"
	       )
	  )
	(alert (strcat "            !!! WARNING !!!"
		       "\n\nStyle with font file \"NASKHD\" or \"NASKHN\"" 
		       "\nis not set."
		       "\nUse \"STYLE\" option for setting text style"
		       "\nwith above font files name."
	       )
	)
      )
    )
  )
  (princ)
)

(princ "..")

(defun mirp (a b)
  (setq x1 (car a) y1 (cadr a) x2 (car b) y2 (cadr b))
  (setq pt3 (list (- (* 2 x1) x2) (- (* 2 y1) y2)))
  (setq an (angle a b))
)

(princ "..")

(defun tvz (so)
  (setq l (strlen so)
	n 1
	nwo ""
  )
  (while (<= n l)
    (if (= n 1)
	 (setq ee " ")
	 (setq ee (substr so (1- n) 1))
    )
    (setq f (substr so n 1))
    (if (= n l)
	 (setq g " ")
	 (setq g (substr so (1+ n) 1))
    )
    (setq asce (ascii ee)
	  ascff (setq ascf (ascii f)) 
	  ascg (ascii g)
    )
    (if (= (member ascf chr2) nil)
      (if (= (member ascf (list 32 95 70 71 72)) nil)
	(progn
	  (if (/= (and (> ascf 64) (< ascf 94)) nil)
	    (setq ascff (setq ascf (+ ascf 32)))
	  )
	  (if (/= (member ascf chr6) nil)
	    (setq ascf (car (cdr (assoc ascf chr5))))
	  )
	  (if (/= (member asce chr3) nil)
	    (if (/= (member ascg chr4) nil)
	      (if (= (member ascf chr7) nil)
		(setq ascf (+ (* (- ascf 97) 3) 132))
		(setq ascf ascff)
	      )
	      (setq ascf ascff)
	    )
	    (if (/= (member ascg chr4) nil)
	      (if (= (member ascf chr7) nil)
		(setq ascf (+ (* (- ascf 97) 3) 131))
		(setq ascf (+ (* (- ascf 97) 3) 130))
	      )
	      (setq ascf (+ (* (- ascf 97) 3) 130))
	    )
	  )
	)
      )
    )
    (setq n (1+ n)
	  nwo (strcat nwo (chr ascf))
    )
  )
  (setq so nwo)
)
\
(princ "..")

(defun hr ()
  (setq f_heigth (cdr (assoc 40 (tblsearch "style" (getvar "textstyle")))))
  (if (= f_heigth 0.0)
    (progn
      (princ (strcat "\nHeight <" (rtos (getvar "textsize")) ">: "))
      (setq ht (getdist st))
      (if (/= ht nil)
	(setvar "textsize" ht)
	(setq ht "")
      )
    )
  )
  (princ (strcat "\nRotation angle <" (angtos (getvar "userr1")) ">: "))
  (setq ro (getangle st))
  (if (/= ro nil)
    (setvar "userr1" ro)
  )
)

(princ "..")

(defun c:sf()
  (setvar "CMDECHO" 0)
  (setvar "HIGHLIGHT" 0)
  (setvar "BLIPMODE" 0)
  (check_style)
  (princ (strcat "Current TEXT style is :  " (getvar "TEXTSTYLE") "\n"))
  (setq st (list 1 4)
	ss (ssadd)
  )
  (command "POINT" "0,0")
  (setq entl (entlast))
  (ssadd entl ss)
  (setq rp "Style")
  (while (= rp "Style")
    (initget "Style Align Center Fit Middle Left")
    (setq rp (getpoint "Start point or Align/Center/Fit/Middle/Left/Style:"))
    (if (= rp "Style")
      (progn
	(setq sty (getstring
		     (strcat "\nStyle name (or ?) <" (getvar "TEXTSTYLE") ">: ")
		  )
	)
	(if (/= sty "")
	  (progn
	    (if (= sty "?")
	      (progn
		(command "TEXT" "S" "?")
		(command)
	      )
	      (progn
		(if (/= (tblsearch "style" sty) nil)
		  (progn
		    (command "TEXT" "S" (eval sty))
		    (command)
		  )
		  (prompt "\nUnknown text style name.\n")
		)
	      )
	    )
	  )
	)
      )
    )
  )
  (if (= (getvar "userr1") 0) (setvar "userr1" pi))
  (if (= rp nil) (setq st nil))
  (if (/= st nil)
    (progn
      (if (listp rp)
	(progn
	  (setq st rp)
	  (lspt st)
	  (hr)
	)
      )
      (if (= rp "Align")
	(progn
	  (setq st (getpoint "\nFirst text line point:"))
	  (lspt st)
	  (setq pt2 (getpoint st "\nSecond text line point:"))
	)
      )
      (if (= rp "Center")
	(progn
	  (setq st (getpoint "\nCenter point:"))
	  (lspt st)
	  (hr)
	)
      )
      (if (= rp "Fit")
	(progn
	  (setq st (getpoint "\nFirst text line point:"))
	  (lspt st)
	  (setq pt2 (getpoint st "\nSecond text line point:")
		f_heigth (cdr (assoc 40 (tblsearch "style" (getvar "textstyle"))))
	  )
	  (if (= f_heigth 0.0)
	    (progn
	      (princ (strcat "\nHeight <" (rtos (getvar "textsize")) ">: "))
	      (setq ht (getdist st))
	      (if (/= ht nil)
		(setvar "textsize" ht)
		(setq ht "")
	      )
	    )
	  )
	)
      )
      (if (= rp "Middle")
	(progn
	  (setq st (getpoint "\nMiddle point:"))
	  (lspt st)
	  (hr)
	)
      )
      (if (= rp "Left")
	(progn
	  (setq st (getpoint "\nLeft point:"))
	  (lspt st)
	  (hr)
	)
      )
    )
  )
  (setq ro (+ (getvar "userr1") pi)
	rl (getvar "AUNITS")
  )
  (cond ((= rl 0) (setq rog (angtos ro)))
    ((= rl 1) (setq rog (angtos ro)))
    ((= rl 2) (setq rog (atof (angtos ro))))
    ((= rl 3) (setq rog (atof (angtos ro))))
    ((= rl 4) (setq rog (r_t_d ro)))
  )
  (princ "\nText:")
  (if (= st nil)
    (command "dtext" "")
    (progn
      (if (listp rp)
	(if (= f_heigth 0.0)
	  (command "dtext" st ht rog)
	  (command "dtext" st rog)
	)
      )
      (if (= rp "Align")
	(progn
	  (mirp st pt2)
	  (command "dtext" "a" st pt3)
	)
      )
      (if (= rp "Center")
	(if (= f_heigth 0.0)
	  (command "dtext" "c" st ht rog)
	  (command "dtext" "c" st rog)
	)
      )
      (if (= rp "Fit")
	(progn
	  (mirp st pt2)
	  (if (= f_heigth 0.0)
	    (command "dtext" "f" st pt3 ht)
	    (command "dtext" "f" st pt3)
	  )
	)
      )
      (if (= rp "Middle")
	(if (= f_heigth 0.0)
	  (command "dtext" "m" st ht rog)
	  (command "dtext" "m" st rog)
	)
      )
      (if (= rp "Left")
	(if (= f_heigth 0.0)
	  (command "dtext" "r" st ht rog)
	  (command "dtext" "r" st rog)
	)
      )
    )
  )
  (while (/= (entnext entl) nil)
    (setq txt (entnext entl)
	  e (entget txt)
    )
    (if (or (= rp "Fit") (= rp "Align"))
      (progn(setq za (cdr (assoc 10 e)))
      (command "ROTATE" (ssadd txt) "" za "180"))
    )
    (setq e (entget txt)
	  s (cdr (setq as (assoc 1 e)))
	  s (tvz s)
	  e (subst (cons 1 nwo) as e)
    )
    (entmod e)
    (setq entl txt)
  )
  (if ss (command "ERASE" ss ""))
  (setvar "HIGHLIGHT" 1)
  (setvar "CMDECHO" 1)
  (setvar "BLIPMODE" 1)
  (princ)
)

(princ "....... Completed.")

(princ)
